-- Deja Mark

BINDING_HEADER_DEJAMARK = "DejaMark"
_G["BINDING_NAME_CLICK DejaMark:LeftButton"] = "Show Markers(Hold)"

local DMM_isClassic
local _, _, _, tocversion = GetBuildInfo()
if (tocversion < 40000) then
	DMM_isClassic = true
end

DM_TARGET_MARKER_ORDER = {};
DM_TARGET_MARKER_ORDER[1] = { wm = 5, wmid = 85000 }	-- Star = TM1, WF5
DM_TARGET_MARKER_ORDER[2] = { wm = 6, wmid = 171555 }	-- Circle = TM2, WF6
DM_TARGET_MARKER_ORDER[3] = { wm = 3, wmid = 84998 }	-- Diamond = TM3, WF3
DM_TARGET_MARKER_ORDER[4] = { wm = 2, wmid = 84997 }	-- Triangle = TM4, WF2
DM_TARGET_MARKER_ORDER[5] = { wm = 7, wmid = 171556 }	-- Moon = TM5, WF7
DM_TARGET_MARKER_ORDER[6] = { wm = 1, wmid = 84996 }	-- Square = TM6, WF1
DM_TARGET_MARKER_ORDER[7] = { wm = 4, wmid = 84999 }	-- Cross = TM7, WF4
DM_TARGET_MARKER_ORDER[8] = { wm = 8, wmid = 171557 }	-- Skull = TM8, WF8
DM_TARGET_MARKER_ORDER[9] = { wm = 9, wmid = nil }		-- None = TM9, WF0

local function DM_ClearPlayer() -- This is the function in the target marking macro; here for reference
	local playerindex = GetRaidTargetIndex("player")
	if playerindex then
		SetRaidTarget("player", 0)
	end
end

local function DM_DesatMarks()
	if not DMM_isClassic then
		for i = 1, 8 do
			local desatButton = _G["DejaMarkIconButton"..i]
			if desatButton then
				local checked = IsRaidMarkerActive(DM_TARGET_MARKER_ORDER[i].wm)
				if checked then
					desatButton.Texture:SetDesaturated(true)
				else
					desatButton.Texture:SetDesaturated(false)
				end
			end
		end
	end
end

local DejaMarkFrame=CreateFrame("Frame","DejaMarkFrame",UIParent)
	DejaMarkFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	DejaMarkFrame:RegisterEvent("EXECUTE_CHAT_LINE")
	DejaMarkFrame:SetClampedToScreen( true )
	DejaMarkFrame:SetMovable(true)
	DejaMarkFrame:EnableMouse(true)
	DejaMarkFrame:SetSize(100,100)
	DejaMarkFrame:SetScale(1.0)
	DejaMarkFrame:Hide()

local t=DejaMarkFrame:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(DejaMarkFrame)
	t:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background")

DejaMarkFrame:SetScript("OnShow", function(self)
	DM_DesatMarks()
end)

DejaMarkFrame:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, ...)
	if (event == "UNIT_SPELLCAST_SUCCEEDED") or (event == "EXECUTE_CHAT_LINE") then
		if (arg1 == "player") then
			for key, wmid in pairs(DM_TARGET_MARKER_ORDER) do
				if DM_TARGET_MARKER_ORDER[key].wmid == arg3 then
					C_Timer.NewTicker(0.025,DM_DesatMarks,10)
				end
			end
		end
		if (arg1 == "/run if (9 == 9) then ClearRaidMarker() end")  then
			C_Timer.NewTicker(0.025,DM_DesatMarks,10)
		end
	end
end)

for key, v in ipairs(DM_TARGET_MARKER_ORDER) do
	local wflare = DM_TARGET_MARKER_ORDER[key].wm
	Button = CreateFrame("Button", "DejaMarkIconButton"..key, DejaMarkFrame, "SecureActionButtonTemplate"); --Use "SecureActionButtonTemplate" if using macros
	Button:RegisterForClicks("LeftButtonDown", "LeftButtonUp", "RightButtonDown", "RightButtonUp")
	Button:SetWidth(32);
	Button:SetHeight(32);
	if(key==9)then
		Button:SetPoint("BOTTOMRIGHT");
	elseif(key==1)then
		Button:SetPoint("TOPLEFT");
	elseif(key==2)then
		Button:SetPoint("TOP");
	elseif(key==3)then
		Button:SetPoint("TOPRIGHT");
	elseif(key==4)then
		Button:SetPoint("LEFT");
	elseif(key==5)then
		Button:SetPoint("BOTTOM");
	elseif(key==6)then
		Button:SetPoint("RIGHT");
	elseif(key==7)then
		Button:SetPoint("BOTTOMLEFT");
	elseif(key==8)then
		Button:SetPoint("CENTER");
	end

	Button.Texture = Button:CreateTexture(Button:GetName().."NormalTexture", "ARTWORK");

	if(key==9)then
		Button.Texture:SetTexture("Interface\\BUTTONS\\UI-GroupLoot-Pass-Up");
	else
		Button.Texture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons");
		SetRaidTargetIconTexture(Button.Texture, key); -- Blizzard specific function that centers sprite texture via index but doesn't include clearing all marks
	end

	Button.Texture:SetAllPoints();
	
	Button:SetScript("OnEnter", function(self, ...)
		self.Texture:ClearAllPoints();
		self.Texture:SetPoint("TOPLEFT", -5, 5);
		self.Texture:SetPoint("BOTTOMRIGHT", 5, -5);
	end);
	
	Button:SetScript("OnLeave", function(self, ...)
		self.Texture:SetAllPoints();
	end);

	if DMM_isClassic then
		Button:SetScript("OnClick", function (self, button, down)
			if (not down) and (button=="LeftButton") then
				if (key == 9) then
					for i = 1, 8 do
						SetRaidTarget("player", i) -- SetRaidTarget is a hard set.  It will not toggle the icon on/off
					end
					local latency = select(4, GetNetStats())/1000
					local framerate = string.format("%.3f", (1/(GetFramerate())))
					local delay = latency + framerate
					C_Timer.NewTicker(delay, DM_ClearPlayer, 4)
				else
					SetRaidTargetIcon("target", key) -- SetRaidTargetIcon toggles the icon on/off
				end
			end
		end)
	else
		Button:SetAttribute("*type1", "macro")
		Button:SetAttribute("*macrotext1", '/run local function DM_ClearPlayer() RunNextFrame(function() local playerindex = GetRaidTargetIndex("player") if playerindex then SetRaidTarget("player", 0) end end) end if SecureCmdOptionParse("[btn:1]") then if ('..key..' == 9) then for i = 1, 8 do SetRaidTarget("player", i) end local latency=select(4, GetNetStats())/1000 local framerate=string.format("%.3f",(1/(GetFramerate()))) local delay=latency+framerate C_Timer.NewTicker(delay,DM_ClearPlayer,10) else SetRaidTargetIcon("target", '..key..') end end')

		if(key==9)then
			Button:SetAttribute("*type2", "macro")
			Button:SetAttribute("*macrotext2", '/run if ('..key..' == 9) then ClearRaidMarker() end')
		else
			Button:SetAttribute("*type2", "worldmarker")	
			Button:SetAttribute("*marker2", wflare)
			Button:SetAttribute("*action2", "set")
		end
	end
end

--toggle frame, has no visible parts. exists as a place to accept a click run a snippet
local toggleframe = CreateFrame("Button","DejaMark",UIParent,"SecureHandlerClickTemplate")
	toggleframe:RegisterForClicks("AnyUp", "AnyDown")
	toggleframe:SetFrameRef("ParentFrame",DejaMarkFrame)
	
	toggleframe:SetAttribute("_onclick",[[
		ParentFrame = self:GetFrameRef("ParentFrame")
		if down then
			ParentFrame:SetPoint("CENTER","$cursor")
			ParentFrame:Show()
		else
			ParentFrame:Hide()
		end
	]])